// x86 port IO routines
// Copyright (c) 2001, David H. Hovemeyer <daveho@cs.umd.edu>
// $Revision: 1.1.1.1 $

// This is free software.  You are permitted to use,
// redistribute, and modify it as specified in the file "COPYING".

#include "io.h"

// Write a byte to an I/O port.
void Out_Byte( unsigned short port, unsigned char value )
{
    __asm__ __volatile__ (
	"outb %b0, %w1"
	:
	: "a" (value), "Nd" (port)
    );
}

// Read a byte from an I/O port.
unsigned char In_Byte( unsigned short port )
{
    unsigned char value;

    __asm__ __volatile__ (
	"inb %w1, %b0"
	: "=a" (value)
	: "Nd" (port)
    );

    return value;
}

// Short delay.  May be needed when talking to some
// (slow) I/O devices.
void IO_Delay( void )
{
    unsigned char value = 0;
    __asm__ __volatile__ (
	"outb %0, $0x80"
	:
	: "a" (value)
    );
}
