// String library
// Copyright (c) 2001, David H. Hovemeyer <daveho@cs.umd.edu>
// $Revision: 1.1.1.1 $

// This is free software.  You are permitted to use,
// redistribute, and modify it as specified in the file "COPYING".

// NOTE:
// These are slow and simple implementations of a subset of
// the standard C library string functions.

#include "string.h"

void* memset( void* s, int c, size_t n )
{
    unsigned char* p = (unsigned char*) s;

    while ( n > 0 ) {
	*p++ = (unsigned char) c;
	--n;
    }

    return s;
}

void* memcpy( void *dst, const void* src, size_t n )
{
    unsigned char* d = (unsigned char*) dst;
    const unsigned char* s = (const unsigned char*) src;

    while ( n > 0 ) {
	*d++ = *s++;
	--n;
    }

    return dst;
}

size_t strlen( const char* s )
{
    size_t len = 0;
    while ( *s++ != '\0' )
	++len;
    return len;
}

int strcmp( const char* s1, const char* s2 )
{
    while ( 1 ) {
	int cmp = *s1 - *s2;
	if ( cmp != 0 || *s1 == '\0' || *s2 == '\0' )
	    return cmp;
	++s1;
	++s2;
    }
}
