/* KMSH - shell of KMOS */

#include "libuser.h"

static inline int *strncmp( char *s1, const char *s2, int n )
{
	char tmp;
	int ret;

	tmp = s1[ n ];
	s1[ n ] = '\0';
	ret = strcmp( s1, s2 );
	s1[ n ] = tmp;

	return ret;
}

void Main( void )
{
	int i, j;
	char buf[79];
	char *tmp;

	Set_Attr( ATTRIB( BLACK, MAGENTA|BRIGHT ) );
	Print_String( "KMSH start\n" );
	Set_Attr( ATTRIB( BLACK, GREEN|BRIGHT ) );

	while ( TRUE )
	{
		Print_String( "KMOS# " );
		Read_Line( buf, sizeof(buf) );

		/* remove space */
		for ( i = 0; i < 79 && buf[ i ] != '\n' ; i++ )
		{
			if ( buf[ i ] == ' ' && ( i == 0 || buf[ i - 1 ] == ' ' ) )
			{
				for ( j = i; j < 79 && buf[ i ] != '\n' ; j++ )
				{
					buf[ j ] = buf[ j + 1 ];
				}

				i--;
			}
		}

		if ( strcmp( buf, "exit\n" ) == 0 )
		{
			break;
		}
		else if ( strcmp( buf, "help\n" ) == 0 )
		{
			Print_String( "help: print this message\n" );
			Print_String( "exit: exit KMSH\n" );
			Print_String( "syscall: call system call\n" );
			continue;
		}
		else if ( buf[0] == '\n' )
		{
			continue;
		}
		else
		{
			if ( strncmp( buf, "syscall", 7 ) == 0 )
			{
				if ( strcmp( buf + 8, "exit\n" ) == 0 )
				{
					exit();
				}
				if ( strcmp( buf + 8, "fork\n" ) == 0 )
				{
					fork();
				}
				else if ( strcmp( buf + 8, "execve\n" ) == 0 )
				{
					execve();
				}
				else if ( strcmp( buf + 8, "open\n" ) == 0 )
				{
					open();
				}
				else if ( strcmp( buf + 8, "read\n" ) == 0 )
				{
					read();
				}
				else if ( strcmp( buf + 8, "close\n" ) == 0 )
				{
					close();
				}
				else if ( strcmp( buf + 8, "waitpid\n" ) == 0 )
				{
					waitpid();
				}
				else if ( strcmp( buf + 8, "getpid\n" ) == 0 )
				{
					getpid();
				}
				else if ( strcmp( buf + 8, "create\n" ) == 0 )
				{
					create();
				}
				else if ( strcmp( buf + 8, "link\n" ) == 0 )
				{
					link();
				}
				else if ( strcmp( buf + 8, "unlink\n" ) == 0 )
				{
					unlink();
				}
				else
				{
					Print_String( "Usage : syscall system_call_name\n" );
					Print_String( "system call name list\n"
							      "fork, execve, open, read, write, close,"
								  " waitpid, getpid, create, link, unlink\n" );
				}

				continue;
			}
		}

		buf[ strlen( buf ) - 1 ] = '\0';
		Print_String( buf );
		Print_String( ": command not found\n" );
	}

	Set_Attr( ATTRIB( BLACK, MAGENTA|BRIGHT ) );
	Print_String( "KMSH exit\n" );
}
