// A library of useful functions for user-mode programs.

#ifndef LIBUSER_H
#define LIBUSER_H

#include <stddef.h>
#include "../string.h"
#include "../screen.h"
#include "../keyboard.h"

// wrappers for system calls
int Null( void );
void exit( void );
int Print_String( const char* message /*, unsigned int attrib*/ );
Keycode Get_Key( void );
void Set_Attr( unsigned int attrib );
int fork( void );
int execve( void );
int open( void );
int read( void );
int write( void );
int close( void );
int waitpid( void );
int getpid( void );
int create( void );
int link( void );
int unlink( void );

// Useful functions.
void Echo( Boolean enable );
void Put_Char( int c );
void Read_Line( char* buf, size_t bufSize );

#endif // LIBUSER_H
