#include "idt.h"
#include "stdio.h"

Idt idt[ NUM_IDT ];

static void test_interrupt()
{
	printf( "Interrupt occur\n" );
}

void init_idt()
{
	int i;
	unsigned short to_idtr[3];
	unsigned long address = (unsigned long)to_idtr;

	printf( "Initialize idt\n" );

	for ( i = 0; i < NUM_IDT; i++ )
	{
		idt[i].offset_low	= (unsigned long)test_interrupt & 0xffff;
		idt[i].ss			= KERNEL_CS;
		idt[i].reversed		= 0;
		idt[i].signature	= 0x70;
		idt[i].dpl			= KERNEL_PRIVILEGE;
		idt[i].present		= 1;
		idt[i].offset_high  = (unsigned long)test_interrupt >> 16;
	}

	to_idtr[0] = NUM_IDT * 8;
	to_idtr[1] = (unsigned short)idt & 0xffff;
	to_idtr[2] = (unsigned short)idt >> 16;

	__asm__ __volatile__
	(
	 	"movl %0, %%eax\n"
	 	"lidt (%%eax)\n"
		: "=m" (address)
	);
}
